VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFunctionContext"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_strFCFunction As String
Private m_strFGUID As String
Private m_intCursorState As Integer
Private m_lngFStart As Long
Private m_lngFStop As Long
Private m_dteFStart As Date
Private m_lngFNumber As Long
Private m_lngStartMem As Long
Private m_lngStopMem As Long
Private m_lngStartObjCount As Long
Private m_lngStopObjCount As Long
Private Sub ClassInitialise()
   Dim ms As MEMORYSTATUS
   
   If g_lngFCNestCount = 0 Then
      Clear
      g_strFCallGUID = GetGUID()
   End If
   
   g_lngFCNestCount = g_lngFCNestCount + 1
   m_lngFNumber = g_lngNextFNumber
   g_lngNextFNumber = g_lngNextFNumber + 1
   
   If g_blnProfile Then
      GlobalMemoryStatus ms
      m_lngStartMem = ms.dwAvailPhys + ms.dwAvailPageFile
   
      m_lngFStart = GetTickCount()
      m_dteFStart = Now
      m_strFGUID = GetGUID()
      m_lngStartObjCount = g_lngObjCount
   End If
   
   m_intCursorState = Screen.MousePointer
End Sub

Private Sub ClassTerminate()
   Dim ms As MEMORYSTATUS
   
   If g_blnProfile Then
      'log function context
      m_lngFStop = GetTickCount()
      m_lngStopObjCount = g_lngObjCount
      
      GlobalMemoryStatus ms
      m_lngStopMem = ms.dwAvailPhys + ms.dwAvailPageFile
      
      If (m_lngFStop - m_lngFStart) >= g_lngMinProfileVal Then
         LogProfile
      End If
   End If
   
   If g_lngFCNestCount > 0 Then
      g_lngFCNestCount = g_lngFCNestCount - 1
   End If
   
   If g_lngFCNestCount = 0 Then
      Clear
   End If
   m_strFGUID = ""

   Screen.MousePointer = m_intCursorState
End Sub

Private Sub Clear()
   g_strFCFunction = ""
   g_strFCError = ""
   g_lngFCError = 0
   g_blnLogged = False
   Err.Clear
   g_strFCallGUID = ""
End Sub

Public Sub CursorBusy()
   Screen.MousePointer = vbHourglass
End Sub

Public Sub DisplayError(Optional strError_a As String = "", Optional blnForce_a As Boolean = False)
   Dim intcursorState
   Dim strError As String
   
   If Not g_blnLogged Then LogError strError_a
   intcursorState = m_intCursorState
   Screen.MousePointer = vbDefault
   
   MsgBox g_strFCError & Chr$(10) & "in " & g_strFCFunction, vbOKOnly, "Error " & g_lngFCError
   strError = g_strFCError & Chr$(10) & "in " & g_strFCFunction
   
   Clear
   
   Screen.MousePointer = intcursorState
   g_blnLogged = False
End Sub

Private Sub LogProfile()
   Dim intFile As Integer
   
   On Error GoTo ErrorTrap
   
   intFile = FreeFile
   Open App.Path & "\" & App.EXEName & ".pro" For Append As #intFile
   Print #intFile, g_strSGUID & "," & App.EXEName & "," & g_lngFCNestCount & "," & m_strFCFunction & "," & m_lngFNumber & "," & (m_lngFStop - m_lngFStart) & "," & Format$(m_dteFStart, "yyyy/mm/dd hh:nn:ss") & "," & m_lngStartMem & "," & m_lngStopMem & "," & m_lngStartObjCount & "," & m_lngStopObjCount
   Close #intFile

ProfileEnd:
   Exit Sub
   
ErrorTrap:
   Resume ProfileEnd
End Sub

Public Sub LogError(Optional strError_a As String = "")
   If g_strFCError = "" Then
      If strError_a = "" Then
         g_strFCFunction = m_strFCFunction
         g_strFCError = Err.Description
         g_lngFCError = Err.Number
      Else
         g_strFCFunction = m_strFCFunction
         g_strFCError = strError_a
         g_lngFCError = 0
      End If
      g_blnLogged = True
   End If
End Sub

Public Property Let Procedure(RHS As String)
   m_strFCFunction = RHS
   If g_blnProfile Then
      If Right$(m_strFCFunction, 17) = ".Class_Initialize" Then g_lngObjCount = g_lngObjCount + 1
      If Right$(m_strFCFunction, 16) = ".Class_Terminate" Then g_lngObjCount = g_lngObjCount - 1
   End If
End Property


Public Sub RaiseError(Optional strError_a As String = "")
   If Not g_blnLogged Then LogError strError_a
   
   If g_lngFCNestCount = 1 Then
      DisplayError
   Else
      Err.Raise g_lngFCError, g_strFCFunction, g_strFCError
   End If
End Sub

Private Sub Class_Initialize()
   ClassInitialise
End Sub


Private Sub Class_Terminate()
   ClassTerminate
End Sub

